<?php
function recuperer_articles()
{
	global $bdd_posh, $tb_article;
	global $ch_art_pubdate;

	$articles = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT * FROM $tb_article ORDER BY $ch_art_pubdate DESC");
		$reponse -> execute(array());
		while ($donnees = $reponse->fetch())
		{
			 $articles[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $articles;
}
function recuperer_articles_recents($nbr_der_activites)
{
	global $bdd_posh, $tb_article;
	global $ch_art_title, $ch_art_pubdate, $ch_art_pubdate;

	$articles = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_art_title, DATE_FORMAT($ch_art_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater FROM $tb_article ORDER BY $ch_art_pubdate DESC LIMIT 0,?");
		$reponse -> bindValue(1, $nbr_der_activites, PDO::PARAM_INT);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{
			 $articles[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $articles;
}
function compter_articles()
{
	global $bdd_posh, $tb_article;
	global $ch_art_id;

	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_art_id) AS cpt_article FROM $tb_article");
		$reponse -> execute(array());
		$donnees = $reponse->fetch();
		$cpt_articles = $donnees['cpt_article'];
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_articles;
}
function compter_articles_sansdesc()
{
	global $bdd_posh, $tb_article;
	global $ch_art_id, $ch_art_description, $ch_art_status;

	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_art_id) AS cpt_article FROM $tb_article WHERE $ch_art_description='' AND $ch_art_status != ?");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_articles = $donnees['cpt_article'];
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_articles;
}
function compter_articles_delete()
{
	global $bdd_posh, $tb_article;
	global $ch_art_id, $ch_art_status;

	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_art_id) AS cpt_article FROM $tb_article WHERE $ch_art_status = ?");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_articles = $donnees['cpt_article'];
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_articles;
}
function compter_articles_sans_gestion()
{
	global $bdd_posh, $tb_article, $tb_article_users, $tb_users;
	global $ch_art_id, $ch_art_status;
	global $ch_art_us_article_id, $ch_art_us_user_id;
	global $ch_users_id;

	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_art_us_article_id) AS cpt_article ".
									  "FROM $tb_article_users, $tb_article ".
									  "WHERE $ch_art_us_user_id NOT IN (SELECT $ch_users_id FROM $tb_users) ".
									  "AND $tb_article_users.$ch_art_us_article_id = $tb_article.$ch_art_id ".
									  "AND $ch_art_status != ?");
		$reponse -> execute(array("D"));
		$donnees = $reponse->fetch();
		$cpt_articles = $donnees['cpt_article'];
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_articles;
}
function compter_articles_intervalle($intervalle)
{
	global $bdd_posh, $tb_article;
	global $ch_art_id, $ch_art_pubdate, $ch_art_status;

	try{
		$reponse = $bdd_posh->prepare("SELECT COUNT($ch_art_id) AS cpt_article FROM $tb_article WHERE $ch_art_pubdate >= DATE_SUB(CURDATE(),INTERVAL ? DAY) AND $ch_art_status != ?");
		$reponse -> execute(array($intervalle,"D"));
		$donnees = $reponse->fetch();
		$cpt_articles = $donnees['cpt_article'];
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $cpt_articles;
}
function desactiver_array_article($array_id)
{
	global $bdd_posh, $tb_article, $tb_groups_articles_map, $tb_comments;
	global $ch_art_id, $ch_art_status;
	global $ch_grp_am_article_id, $ch_grp_am_status;
	global $ch_cts_article_id, $ch_cts_status;

    foreach($array_id as $id) {
        try{
            $reponse = $bdd_posh->prepare("UPDATE $tb_article SET $ch_art_status = ? WHERE $ch_art_id = ?");
            $reponse -> execute(array("D",$id));
            $reponse -> closeCursor();

            $reponse = $bdd_posh->prepare("UPDATE $tb_groups_articles_map SET $ch_grp_am_status = ? WHERE $ch_grp_am_article_id = ?");
            $reponse -> execute(array("D",$id));
            $reponse -> closeCursor();

            $reponse = $bdd_posh->prepare("UPDATE $tb_comments SET $ch_cts_status = ? WHERE $ch_cts_article_id = ?");
            $reponse -> execute(array("D",$id));
            $reponse -> closeCursor();
        }catch (Exception $e)
        {
            die('Erreur : ' . $e->getMessage());
            return false;
        }
    }
	return true;
}
function reactiver_array_article($array_id)
{
	global $bdd_posh, $tb_article, $tb_groups_articles_map, $tb_comments;
	global $ch_art_id, $ch_art_status, $ch_art_commentsnb;
	global $ch_grp_am_article_id, $ch_grp_am_status;
	global $ch_cts_id, $ch_cts_article_id, $ch_cts_status;

    foreach($array_id as $id) {
        try{
            $reponse = $bdd_posh->prepare("UPDATE $tb_article SET $ch_art_status = ? WHERE $ch_art_id = ?");
            $reponse -> execute(array("2",$id));
            $reponse -> closeCursor();

            $reponse = $bdd_posh->prepare("UPDATE $tb_groups_articles_map SET $ch_grp_am_status = ? WHERE $ch_grp_am_article_id = ?");
            $reponse -> execute(array("2",$id));
            $reponse -> closeCursor();

            $reponse = $bdd_posh->prepare("UPDATE $tb_comments SET $ch_cts_status = ? WHERE $ch_cts_article_id = ?");
            $reponse -> execute(array("O",$id));
            $reponse -> closeCursor();

            //On remet le compteur des comentaires à jour
            $reponse = $bdd_posh->prepare("SELECT count($ch_cts_id) FROM $tb_comments WHERE $ch_cts_article_id = ?");
            $reponse -> execute(array($id));
            $number_of_rows = $reponse->fetchColumn();

            $reponse = $bdd_posh->prepare("UPDATE $tb_article SET $ch_art_commentsnb = ? WHERE $ch_art_id = ?");
            $reponse -> execute(array($number_of_rows, $id));
            $reponse -> closeCursor();
        }catch (Exception $e)
        {
            die('Erreur : ' . $e->getMessage());
            return false;
        }
    }
	return true;
}
function supprimer_array_article($array_id)
{
	global $bdd_posh, $tb_article, $tb_groups_articles_map, $tb_comments;
	global $ch_art_id, $ch_art_status;
	global $ch_grp_am_article_id, $ch_grp_am_status;
	global $ch_cts_article_id, $ch_cts_status;

    foreach($array_id as $id) {
        try{
            $reponse = $bdd_posh->prepare("DELETE FROM $tb_article WHERE $ch_art_status = ? AND $ch_art_id = ?");
            $reponse -> execute(array("D",$id));
            $reponse -> closeCursor();

            $reponse = $bdd_posh->prepare("DELETE FROM $tb_groups_articles_map WHERE $ch_grp_am_status = ? AND $ch_grp_am_article_id = ?");
            $reponse -> execute(array("D",$id));
            $reponse -> closeCursor();

            $reponse = $bdd_posh->prepare("DELETE FROM $tb_comments WHERE $ch_cts_status = ? AND $ch_cts_article_id = ?");
            $reponse -> execute(array("D",$id));
            $reponse -> closeCursor();
        }catch (Exception $e)
        {
            die('Erreur : ' . $e->getMessage());
            return false;
        }
    }
	return true;
}
function recuperer_articles_total()
{
	global $bdd_posh, $tb_article;
	global $ch_art_id, $ch_art_title, $ch_art_status, $ch_art_pubdate, $ch_art_type;

	$articles = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_art_id, $ch_art_title, $ch_art_status, DATE_FORMAT($ch_art_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $ch_art_type ".
									  "FROM $tb_article");
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{
			 $articles[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $articles;
}
function recuperer_articles_vide_desc()
{
	global $bdd_posh, $tb_article;
	global $ch_art_id, $ch_art_title, $ch_art_status, $ch_art_pubdate, $ch_art_description, $ch_art_type;

	$articles = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_art_id, $ch_art_title, $ch_art_status, DATE_FORMAT($ch_art_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $ch_art_type ".
									  "FROM $tb_article ".
									  "WHERE $ch_art_description='' ".
									  "AND $ch_art_status != ?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{
			 $articles[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $articles;
}
function recuperer_articles_intervalle($intervalle)
{
	global $bdd_posh, $tb_article;
	global $ch_art_id, $ch_art_title, $ch_art_status, $ch_art_pubdate, $ch_art_type;

	$articles = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_art_id, $ch_art_title, $ch_art_status, DATE_FORMAT($ch_art_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $ch_art_type ".
									  "FROM $tb_article ".
									  "WHERE $ch_art_pubdate >= DATE_SUB(CURDATE(),INTERVAL ? DAY) ".
									  "AND $ch_art_status != ?");
		$reponse -> bindValue(1, $intervalle, PDO::PARAM_INT);
		$reponse -> bindValue(2, "D", PDO::PARAM_STR);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{
			 $articles[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $articles;
}
function recuperer_articles_delete()
{
	global $bdd_posh, $tb_article;
	global $ch_art_id, $ch_art_title, $ch_art_status, $ch_art_pubdate, $ch_art_type;

	$articles = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_art_id, $ch_art_title, $ch_art_status, DATE_FORMAT($ch_art_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $ch_art_type ".
									  "FROM $tb_article ".
									  "WHERE $ch_art_status = ?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{
			 $articles[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $articles;
}
function recuperer_articles_sans_gestion()
{
	global $bdd_posh, $tb_article, $tb_article_users, $tb_users;
	global $ch_art_id, $ch_art_title, $ch_art_status, $ch_art_pubdate, $ch_art_type;
	global $ch_art_us_article_id, $ch_art_us_user_id;
	global $ch_users_id;

	$articles = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_art_id, $ch_art_title, $ch_art_status, DATE_FORMAT($tb_article.$ch_art_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $ch_art_type ".
									  "FROM $tb_article_users, $tb_article ".
									  "WHERE $ch_art_us_user_id NOT IN (SELECT $ch_users_id FROM $tb_users) ".
									  "AND $tb_article_users.$ch_art_us_article_id = $tb_article.$ch_art_id ".
									  "AND $ch_art_status != ?");
		$reponse -> bindValue(1, "D", PDO::PARAM_STR);
		$reponse -> execute();
		while ($donnees = $reponse->fetch())
		{
			 $articles[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $articles;
}
function recuperer_infos_article($id)
{
	global $bdd_posh, $tb_article;
	global $ch_art_id, $ch_art_title, $ch_art_status, $ch_art_pubdate, $ch_art_description, $ch_art_keywords, $ch_art_commentsnb, $ch_art_type;

	$infos = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_art_title, $ch_art_description, $ch_art_keywords, DATE_FORMAT($ch_art_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater, $ch_art_commentsnb, $ch_art_status, $ch_art_type ".
									  "FROM $tb_article ".
									  "WHERE $ch_art_id = ?");
		$reponse -> execute(array($id));
		while ($donnees = $reponse->fetch())
		{
			 $infos[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $infos;
}
function recuperer_userowner_article($id)
{
	global $bdd_posh, $tb_article_users, $tb_users;
	global $ch_art_us_user_id, $ch_art_us_article_id, $ch_art_us_owner_id, $ch_art_us_pubdate;
	global $ch_users_id, $ch_users_username;

	$infos = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_art_us_user_id, $ch_art_us_article_id, $ch_art_us_owner_id, $ch_users_username, DATE_FORMAT($ch_art_us_pubdate, \"%d/%m/%Y à %Hh%i\") AS pubdate_formater ".
									  "FROM $tb_article_users, $tb_users ".
									  "WHERE $tb_article_users.$ch_art_us_user_id = $tb_users.$ch_users_id ".
									  "AND $ch_art_us_article_id = ?");
		$reponse -> execute(array($id));
		while ($donnees = $reponse->fetch())
		{
			 $infos[] = $donnees;
		}
		$reponse -> closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $infos;
}
function recuperer_article_recherche($texte)
{
	global $bdd_posh, $tb_article;
	global $ch_art_id, $ch_art_title, $ch_art_description;

	$articles = array();
	try{
		$reponse = $bdd_posh->prepare("SELECT $ch_art_id, $ch_art_title, $ch_art_description ".
									  "FROM $tb_article ".
									  "WHERE $ch_art_title LIKE '%' ? '%'".
									  "OR $ch_art_description LIKE '%' ? '%'");
		$reponse -> execute(array($texte,$texte));
		while($donnees = $reponse->fetch())
		{
			$articles[] = $donnees;
		}
		$reponse->closeCursor();
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
	}
	return $articles;
}
function purger_articles()
{
	global $bdd_posh, $tb_article, $tb_comments, $tb_groups_articles_map, $tb_article_keywords, $tb_article_users, $tb_article_doc_map;
	try{
		$reponse = $bdd_posh->prepare("TRUNCATE TABLE $tb_comments;
                                       TRUNCATE TABLE $tb_groups_articles_map;
                                       TRUNCATE TABLE $tb_article;
                                       TRUNCATE TABLE $tb_article_keywords;
                                       TRUNCATE TABLE $tb_article_users;
                                       TRUNCATE TABLE $tb_article_doc_map");
		$reponse -> execute(array());
		$reponse -> closeCursor();
		return true;
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
		return false;
	}
}
function purger_articles_date($date_purge)
{
    global $bdd_posh, $tb_article, $tb_comments, $tb_groups_articles_map, $tb_article_keywords, $tb_article_users, $tb_article_doc_map;
    global $ch_art_id, $ch_art_pubdate;
	try{
        $reponse = $bdd_posh->prepare("SELECT $ch_art_id FROM $tb_article WHERE $ch_art_pubdate < ?");
		$reponse -> execute(array($date_purge));

        foreach($reponse as $row){
            $reponse = $bdd_posh->prepare("DELETE FROM $tb_comments WHERE article_id = ?");
            $reponse -> execute(array($row[$ch_art_id]));
            $reponse -> closeCursor();

            $reponse = $bdd_posh->prepare("DELETE FROM $tb_groups_articles_map WHERE article_id = ?");
            $reponse -> execute(array($row[$ch_art_id]));
            $reponse -> closeCursor();

            $reponse = $bdd_posh->prepare("DELETE FROM $tb_article WHERE id = ?");
            $reponse -> execute(array($row[$ch_art_id]));
            $reponse -> closeCursor();

            $reponse = $bdd_posh->prepare("DELETE FROM $tb_article_keywords WHERE article_id = ?");
            $reponse -> execute(array($row[$ch_art_id]));
            $reponse -> closeCursor();

            $reponse = $bdd_posh->prepare("DELETE FROM $tb_article_users WHERE article_id = ?");
            $reponse -> execute(array($row[$ch_art_id]));
            $reponse -> closeCursor();

            $reponse = $bdd_posh->prepare("DELETE FROM $tb_article_doc_map WHERE article_id = ?");
            $reponse -> execute(array($row[$ch_art_id]));
            $reponse -> closeCursor();
        }

        $reponse->closeCursor();
		return true;
	}catch (Exception $e)
	{
		die('Erreur : ' . $e->getMessage());
		return false;
	}
}
