<?php
/**********************************************************************************************************/
/*********************************************** Fonctions LDAP *******************************************/
/**********************************************************************************************************/
function recup_infos_ldap($user_login){
	require dirname(__FILE__).'/../config/ldap.inc.php';
	try{
		$ldapconn = ldap_connect($ldaphost,$ldapport) or die("Impossible de se connecter au serveur LDAP {$ldaphost}");
		$infos_user_ldap = array();
		if($ldapconn){
			$ldapbind = ldap_bind($ldapconn);
	 		if($ldapbind){
	    		$filtre = $ldap_uid."=".$user_login;
		        $read = ldap_search($ldapconn,$ldapdn,$filtre);
		        $info = ldap_get_entries($ldapconn,$read);
				if(isset($info[0][$ldap_cn][0])){
		        	 $infos_user_ldap[0] = $info[0][$ldap_cn][0];
		        }
		        if(isset($info[0][$ldap_mail][0])){
		        	$infos_user_ldap[1] = $info[0][$ldap_mail][0];
		        }
	    	}else{
	       		echo 'Connexion LDAP anonmye échouée';
	    	}
		}else{
			echo 'Erreur de connection au serveur LDAP';
		}
		ldap_close($ldapconn);
	}catch(Exception $e){
		echo 'Exception : '.$e->getMessage();
	}
	return $infos_user_ldap;
}
function is_user_exist_uid($uid){
	require dirname(__FILE__).'/../config/ldap.inc.php';
	try{
		$ldapconn = ldap_connect($ldaphost,$ldapport) or die("Impossible de se connecter au serveur LDAP {$ldaphost}");
		if($ldapconn){
			$ldapbind = ldap_bind($ldapconn);
	 		if($ldapbind){
	    		$filtre = $ldap_uid."=".$uid;
		        $read = ldap_search($ldapconn,$ldapdn,$filtre);
		        $info = ldap_get_entries($ldapconn,$read);
				if(empty($info[0][$ldap_uid][0])){
					return false;
				}else{
					return true;
				}
	    	}else{
	       		echo 'Connexion LDAP anonmye échouée';
	    	}
		}else{
			echo 'Erreur de connection au serveur LDAP';
		}
	}catch(Exception $e){
		echo 'Exception : '.$e->getMessage();
	}
	ldap_close($ldapconn);
}
//Fonction qui renvoi le type d'article
function type_article($type_in){
	switch($type_in){
			case "1":
				$type = "Article";
				break;
			case "3":
				$type = "Widget partagé";
				break;
			case "4":
				$type = "Onglet partagé";
				break;
			case "6":
				$type = "Status";
				break;
			case "9":
				$type = "Évenement";
				break;
			default :
				$type = "Autre";
				break;
		}
	return $type;
}
//Fonction de redirection
function redir($adresse)
{
	echo "<script type=\"text/javascript\">  window.location.replace(\"".$adresse."\");  </script>";
	exit();
}
//Formatage d'une date au format JJ/MM/AAAA en AAAA-MM-DD
function format_date_inv($date){
	$jour = substr($date, 0, 2);
	$mois = substr($date, 3, 2);
	$annee = substr($date, 6, 4);
	$date_format = $annee.'-'.$mois.'-'.$jour;
	return $date_format;
}